/*************************************************************************
 * reech-def.h -
 *
 * $Id: reech-def.begin,v 1.2 2000/10/18 08:45:56 greg Exp $
 *
 * Copyright (c) INRIA 1999
 *
 * AUTHOR:
 * Gregoire Malandain (greg@sophia.inria.fr)
 * 
 * CREATION DATE: 
 *
 *
 * ADDITIONS, CHANGES
 *	
 *	
 *	
 *
 */


/* CAUTION
   DO NOT EDIT THIS FILE,
   UNLESS YOU HAVE A VERY GOOD REASON 
 */

#ifndef _reech_def_h_
#define _reech_def_h_

#ifdef __cplusplus
extern "C" {
#endif

#include <typedefs.h>



extern void setVerboseInReechDef( int v );
extern void incrementVerboseInReechDef(  );
extern void decrementVerboseInReechDef(  );



extern void Reech3DTriLinVectorField_r32_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech3DTriLinVectorFieldgb_r32_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech3DNearestVectorField_r32_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorField_r32_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorFieldgb_r32_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech2DNearestVectorField_r32_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );



extern void Reech3DTriLinVectorField_r32_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech3DTriLinVectorFieldgb_r32_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech3DNearestVectorField_r32_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorField_r32_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorFieldgb_r32_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech2DNearestVectorField_r32_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );



extern void Reech3DTriLinVectorField_r32_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech3DTriLinVectorFieldgb_r32_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech3DNearestVectorField_r32_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorField_r32_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorFieldgb_r32_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech2DNearestVectorField_r32_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );



extern void Reech3DTriLinVectorField_r32_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech3DTriLinVectorFieldgb_r32_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech3DNearestVectorField_r32_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorField_r32_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorFieldgb_r32_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech2DNearestVectorField_r32_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );



extern void Reech3DTriLinVectorField_r32_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech3DTriLinVectorFieldgb_r32_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech3DNearestVectorField_r32_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorField_r32_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorFieldgb_r32_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech2DNearestVectorField_r32_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r32** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );



extern void Reech3DTriLinVectorField_r64_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech3DTriLinVectorFieldgb_r64_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech3DNearestVectorField_r64_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorField_r64_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorFieldgb_r64_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech2DNearestVectorField_r64_u8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );



extern void Reech3DTriLinVectorField_r64_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech3DTriLinVectorFieldgb_r64_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech3DNearestVectorField_r64_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorField_r64_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorFieldgb_r64_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech2DNearestVectorField_r64_s8 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );



extern void Reech3DTriLinVectorField_r64_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech3DTriLinVectorFieldgb_r64_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech3DNearestVectorField_r64_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorField_r64_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorFieldgb_r64_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech2DNearestVectorField_r64_u16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );



extern void Reech3DTriLinVectorField_r64_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech3DTriLinVectorFieldgb_r64_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech3DNearestVectorField_r64_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorField_r64_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorFieldgb_r64_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech2DNearestVectorField_r64_s16 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );



extern void Reech3DTriLinVectorField_r64_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech3DTriLinVectorFieldgb_r64_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech3DNearestVectorField_r64_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorField_r64_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );

extern void Reech2DTriLinVectorFieldgb_r64_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef,  /* transformation matrix */
			     float gain,
			     float bias );

extern void Reech2DNearestVectorField_r64_r32 ( void* theBuf, /* buffer to be resampled */
			     int *theDim,  /* dimensions of this buffer */
			     void* resBuf, /* result buffer */
			     int *resDim,  /* dimensions of this buffer */
			     r64** theDef, /* deformations */
                             int *defDim, /* dimensions of these buffers */
			     double* mat_aft,  /* transformation matrix */
			     double* mat_bef  /* transformation matrix */
			     );



#ifdef __cplusplus
}
#endif

#endif
