/*************************************************************************
 * reech4x4.c -
 *
 * $Id: reech4x4.begin,v 1.3 2001/12/10 08:45:17 greg Exp $
 *
 * Copyright (c) INRIA 1999
 *
 * AUTHOR:
 * Gregoire Malandain (greg@sophia.inria.fr)
 * 
 * CREATION DATE: 
 *
 *
 * ADDITIONS, CHANGES
 *	
 *	
 *	
 *
 */


/* CAUTION
   DO NOT EDIT THIS FILE,
   UNLESS YOU HAVE A VERY GOOD REASON 
 */

#include <stdio.h>
#include <stdlib.h>

#include <typedefs.h>
#include <chunks.h>

#include <cspline.h>
#include <cspline4x4.h>



#define _CONVERTR_(R) ( R )
#define _CONVERTI_(R) ( (R) >= 0.0 ? ((int)((R)+0.5)) : ((int)((R)-0.5)) )
static int _verbose_ = 1;




void setVerboseInCspline4x4( int v )
{
  _verbose_ = v;
}

void incrementVerboseInCspline4x4(  )
{
  _verbose_ ++;
}

void decrementVerboseInCspline4x4(  )
{
  _verbose_ --;
  if ( _verbose_ < 0 ) _verbose_ = 0;
}





/* Fonctions pour l'interpolation spline cubique.
   A. Roche
*/


/* Cette fonction renvoie la valeur de la fonction B-spline
   cubique elementaire en x */

static double CubicBspline ( double x )
{
  double aux;

  if ( x >= 0.0 ) {
    if ( x >=  2.0 ) return( 0.0 );
    if ( x < 1 ) {
      aux = x*x;
      return( (double)2.0/(double)3.0 - aux + (double)0.5*aux*x );
    }
    aux = 2.0 - x;
    return( aux*aux*aux/(double)6.0 );
  }

  /* ici x < 0
   */
  if ( x <= -2.0 ) return( 0.0 );
  if ( x > -1 ) {
    aux = x*x;
    return( (double)2.0/(double)3.0 - aux - (double)0.5*aux*x );
  }
  aux = 2.0 + x;
  return( aux*aux*aux/(double)6.0 );
}





static double CubicBspline_FirstDeriv ( double x )
{
  if ( x == 0.0 ) return( 0.0 );

  if ( x > 0.0 ) {
    if ( x >=  2.0 ) return( 0.0 );
    if ( x < 1 ) {
      return( (-2.0 + 1.5*x)*x );
    }
    return( -0.5 * (2.0-x) * (2.0-x) );
  }

  /* ici x < 0
   */
  if ( x <= -2.0 ) return( 0.0 );
  if ( x > -1 ) {
    return( (-2.0 - 1.5*x)*x );
  }
  return( 0.5 * (2.0+x) * (2.0+x) );
}




static double CubicBspline_SecndDeriv ( double x )
{
  if ( x > 0.0 ) {
    if ( x >=  2.0 ) return( 0.0 );
    if ( x < 1 ) {
      return( -2.0 + 3.0*x );
    }
    return( 2.0 - x );
  }

  /* ici x < 0
   */
  if ( x <= -2.0 ) return( 0.0 );
  if ( x > -1 ) {
    return( -2.0 - 3.0*x );
  }
  return( 2.0 + x );
}





typedef struct {
  typeCSplineCoefficients *theCoeff; /* cspline coefficients */
  void* resBuf; /* result buffer */
  int *resDim;  /* dimensions of this buffer */
  double* mat;  /* transformation matrix */
  int* derivative; /* derivative orders */
  float gain;
  float bias;
} _CsplineResamplingParam;
